<template>
  <div class="template">
    <form class="form">
      <div class="formElement">
        <label v-if="status != 'login'">Votre adresse mail</label>
        <input
          id="email"
          type="email"
          name="email"
          placeholder="Saisissez ici votre email"
          v-model="email"
          @focusout="isEmailValid"
          v-if="status != 'login'"
        />
        <p v-if="emailError">Veuillez entrer un email correct</p>
      </div>
      <div class="formElement">
        <label v-if="status != 'login'">Mot de passe</label>
        <input
          id="password"
          type="password"
          v-model="password"
          name="pasword"
          placeholder="Saisissez ici votre mot de passe"
          v-if="status != 'login'"
          @focusout="isPasswordValid"
        />
        <p v-if="passwordError">
          Le mot de passe doit comporter entre 4 et 8 caractères et inclure au moins un
          chiffre.
        </p>
      </div>
      <div v-if="status !== 'login'" class="formElement">
        <button
          id="login"
          type="submit"
          @click="login"
          :disabled="validatedFields == false"
        >
          <span v-if="status == 'loading'">Connexion en cours</span>
          <span v-else>Se connecter</span>
        </button>
      </div>
      <div v-if="status == 'login'" class="formElement">
        <button v-if="status == 'login'" id="logout" type="submit" @click="logout">
          Se deconnecter
        </button>
      </div>
      <div class="form-row" v-if="status == 'error_login'">
        Adresse ou mot de pas incorrecte
      </div>
    </form>
  </div>
</template>

<script>
import { mapState } from "vuex";

export default {
  name: "LoginView",
  data() {
    return {
      identificationUser: {},
      isLogin: false,
      email: "",
      password: "",
      emailError: "",
      passwordError: "",
      regEmail: /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/gim,
      regPassword: /^(?=.*\d).{4,8}$/gim,
    };
  },
  
  computed: {
    validatedFields() {
      if (this.emailError == true || this.passwordError == true) {
        return false;
      } else {
        return true;
      }
    },
    ...mapState(["status"]),
  },

  methods: {
    isEmailValid() {
      if (this.email !== "" && this.regEmail.test(this.email)) {
        this.emailError = false;
      } else {
        this.emailError = true;
      }
    },
    isPasswordValid() {
      if (this.password !== "" && this.regPassword.test(this.password)) {
        this.passwordError = false;
      } else {
        this.passwordError = true;
      }
    },

    login(event) {
      event.preventDefault();
      const self = this;
      this.$store
        .dispatch("login", {
          email: this.email,
          password: this.password,
        })
        .then(
          (response) => {
            console.log(response);
            self.$router.push("/network");
          },
          function (error) {
            console.log(error);
          }
        );
    },
    logout() {
      this.$store.commit("logout");
      this.$store.commit("setStatus", "");
      alert("Vous avez été deconnecté");
      this.$router.push("/");
    },
  },
};
</script>

<style lang="scss" scoped>
.template {
  background-image: url("../assets/logos/icon.svg");
  background-attachment: fixed;
  background-repeat: no-repeat;
}
.form {
  font-size: large;
  text-align: start;
  &Element {
    display: grid;
    grid-template-columns: 1fr 2fr;
    justify-content: space-around;
    margin: 50px;
    padding: 20px;
  }
}
label,
input,
button {
  display: block;
}

label,
p {
  padding-left: 20px;
}
input,
button {
  border-radius: 40px;
  border: solid 1px blue;
  width: 300px;
  height: 50px;
  font-size: 20px;

  &:hover {
    background-color: rgb(160, 160, 238);
  }
}
button {
  font-size: large;
  border-radius: 40px;
  background-color: transparent;
  grid-column: 2;
  margin-top: 20px;
}
p {
  color: rgb(94, 5, 5);
  font-style: italic;
  font-weight: lighter;
}

@media screen and (max-width: 660px) {
  .template {
    padding-top: 150px;
  }
  input,
  button {
    display: block;
  }
  label {
    text-align: center;
  }
  .form {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    &Element {
      display: flex;
      flex-direction: column;
      justify-content: center;
      margin: 10px;
      padding: 0px;
    }
  }
}
</style>
